Lib.Gui.behaviour = {};


//REFACTORED #################################################################

Lib.Gui.behaviour.rand = (function() {

    var obj = {};

    function apply(opts) {
        //arg check
        var opts = opts || {};
        var element = Lib.check.isObject(opts.element) && Lib.check.objHasOwnProps(opts.element, ["obj"]) ? opts.element : {};
        var minRandTime = Lib.check.isNumber(opts.minRandTime) ? opts.minRandTime : 4;
        var maxRandTime = Lib.check.isNumber(opts.maxRandTime) ? opts.maxRandTime : 6;
        var func = Lib.check.isFunction(opts.func) ? opts.func : Lib.fxFunc.once.jellyVibe;

        if (Lib.check.isEmptyOrUndefinedObj(element)) {
            Lib.glob.warn("ELement does not have obj property or is undefined");
            return -1;
        }

        //other vars 
        var event = undefined;
        var randTime = Lib.UTILS.randFloat(minRandTime, maxRandTime);
        //---------------------------------

        // randFunc(element.obj);
        event = game.time.events.add(Phaser.Timer.SECOND * randTime, nextEvent, this);

        function nextEvent() {
            randTime = Lib.UTILS.randFloat(minRandTime, maxRandTime);
            func(element.obj);
            event = game.time.events.add(Phaser.Timer.SECOND * randTime, nextEvent, this);
        }
    }

    obj.apply = apply;

    return obj;

}());


Lib.Gui.behaviour.cont = (function() {
    var obj = {};

    function apply(opts) {
        //arg check
        var opts = opts || {};
        var element = Lib.check.isObject(opts.element) && Lib.check.objHasOwnProps(opts.element, ["obj"]) ? opts.element : {};
        var func = Lib.check.isFunction(opts.func) ? opts.func : Lib.fxFunc.cont.superSlowScaleMove;

        if (Lib.check.isEmptyOrUndefinedObj(element)) {
            Lib.glob.warn("ELement does not have obj property or is undefined");
            return -1;
        }

        func(element.obj);
    }


    obj.apply = apply;

    return obj;
}());

//Mutually exclusive with introOther because they both disable and enable input
Lib.Gui.behaviour.introMove = (function() {
    var obj = {};

    function apply(opts) {
        var opts = opts || {};
        var element = Lib.check.isObject(opts.element) && Lib.check.objHasOwnProps(opts.element, ["obj"]) ? opts.element : {};
        //Req: takes obj,destinationPoint and enableInput as args. callback is set to enableInput and context to this
        //req: x is set to destinationPoint.x and y is set to destinationPoint.y
        var func = Lib.check.isFunction(opts.func) ? opts.func : Lib.fxFunc.introMove.travelLinear;
        var startPoint = Lib.check.isObject(opts.startPoint) && Lib.check.objHasProps(opts.startPoint, ["x", "y"]) ? opts.startPoint : new Phaser.Point(0, 0);


        var destinationPoint = element.obj.position;

        disableInput();
        element.obj.position = startPoint;
        func(element.obj, destinationPoint, enableInput);

        function enableInput() {
            element.obj.setInput(true);
        }

        function disableInput() {
            element.obj.setInput(false);
        }

    }

    obj.apply = apply;

    return obj;
}());


Lib.Gui.behaviour.introOther = (function() {
    var obj = {};

    function apply(opts) {
        var opts = opts || {};
        var element = Lib.check.isObject(opts.element) && Lib.check.objHasOwnProps(opts.element, ["obj"]) ? opts.element : {};
        //Req: takes obj,destinationPoint and enableInput as args. callback is set to enableInput and context to this
        //req: x is set to destinationPoint.x and y is set to destinationPoint.y
        var func = Lib.check.isFunction(opts.func) ? opts.func : Lib.fxFunc.introOther.alphaAppear;



        disableInput();
        func(element.obj, enableInput);

        function enableInput() {
            element.obj.setInput(true);
        }

        function disableInput() {
            element.obj.setInput(false);
        }

    }

    obj.apply = apply;

    return obj;
}());


Lib.Gui.behaviour.click = (function() {
    var obj = {};

    function apply(opts) {
        var opts = opts || {};
        var element = Lib.check.isObject(opts.element) && Lib.check.objHasOwnProps(opts.element, ["obj"]) ? opts.element : {};
        //Req: takes context an arg, callback is set to context.mainCallback, context is set to context
        var func = Lib.check.isFunction(opts.func) ? opts.func : Lib.fxFunc.click.flash;
        applyOnClickFunc(element, func);

    }

    obj.apply = apply;

    function applyOnClickFunc(element, onClickFunc) {
        element.onClickFunc = onClickFunc;
    }

    return obj;
}());